#include <bits/stdc++.h>

using namespace std;

#define X			first
#define Y			second
#define endl		'\n'

void writeTest( int n, int k, int q, int seed, int minA, int maxA ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "wt", stdout );

	cout << n << " " << k << " " << q << endl;
	cout << seed << " " << minA << " " << maxA << endl;
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

vector< int > randVector( int n, int l, int r ) {
	vector< int > v( n );
	for( int i = 0; i < n; i ++ ) {
		int x = randNumber( l, r );
		v[i] = x;
	}
	sort( v.begin(), v.end() );
	return v;
}

int getQ( int subtask, int n, int k ) {
	switch( subtask ) {
	case 1: return 5;
	case 2: return 1000;
	case 3: return 1000;
	case 4: return 125;
	case 5: return 125;
	case 6: return 125;
	case 7: return 125;
	case 8: return n;
	case 9: return 1700;
	case 10: return 1900;
	case 11: return 1800;
	case 12: return 2600;
	case 13: return k;
	}
}

void getNK( int &n, int &k, int mode, int NmodK ) {
	if( mode == 0 )
		return;
	n /= k;
	n *= k;
	if( n == 0 )
		n = k;
	if( mode == 1 )
		n -= k / 2;
	if( mode == 2 )
		n -= min( k - NmodK, NmodK );
	if( mode == 3 )
		n -= randNumber( 1, k );
	n = max( 1, n );
	n = min( 1000000, n );
}

int solve( int n, int k, vector< int > &v ) {
	if( n <= k )
		return 0;
	int d1 = n / k;
	int d2 = d1 + 1;
	int m2 = n % k;
	int m1 = k - m2;
	vector< long long > dp( n + 1, 1e9 );
	vector< int > p1( n + 1, 0 ), p2( n + 1, 0 );
	dp[0] = 0;
	p1[0] = m1;
	p2[0] = m2;
	for( int i = 1; i <= n; i ++ ) {
		if( i >= d1 && p1[i - d1] > 0 ) {
			dp[i] = min( dp[i], dp[i - d1] + abs( v[i - 1] - v[i - d1] ) );
			p1[i] = p1[i - d1] - 1;
			p2[i] = p2[i - d1];
		}
		if( i >= d2 && p2[i - d2] > 0 ) {
			dp[i] = min( dp[i], dp[i - d2] + abs( v[i - 1] - v[i - d2] ) );
			p1[i] = p1[i - d2];
			p2[i] = p2[i - d2] - 1;
		}
	}
	return dp.back();
}

int main( int argc, char *argv[] ) {
	int test = atol( argv[1] );
	int subtask = atol( argv[2] );
	int minN = atol( argv[3] );
	int maxN = atol( argv[4] );
	int minK = atol( argv[5] );
	int maxK = atol( argv[6] );
	int mode = atol( argv[7] );
	int NmodK = atol( argv[8] );
	int minA = atol( argv[9] );
	int maxA = atol( argv[10] );

	int seed = test + subtask + minN + maxN + minK + maxK + mode + NmodK + minA + maxA;

	srand( seed );

	maxN = max( minN, maxN );
	maxK = max( minK, maxK );

	int n = randNumber( minN, maxN );
	int k = randNumber( minK, maxK );

	getNK( n, k, mode, NmodK );

	int q = getQ( subtask, n, k );

	writeTest( n, k, q, seed, minA, maxA );
    return 0;
}
